;--------------------------------------------------
;   Hello Windows Resolution Testing Program
;   06-12-2005 by J.P. Shankle
;   Written using windows XP, 19" monitor
;   Also tested on a 17" MONITOR 
; -------------------------------------------------

.486
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

WinMain           PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data               
AppName          db   'The Hello Program',0
Windowsmsg       db   'Hello, Windows 95!',0
szDisplayName    db   'Hello Windows',0

.data?
CommandLine   LPSTR     ?
hInstance     dd        ?
rect          RECT      {?}
 
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX, msg: MSG, hwnd: HWND, hBrush: DWORD, hdc: HDC, rr: RECT
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
 	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInst
	pop   wc.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
      invoke LoadCursor, NULL,IDC_ARROW
	mov   wc.hCursor, eax
      invoke GetStockObject, (WHITE_BRUSH) 
      mov   hBrush, eax
	mov   wc.hbrBackground, eax 
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, OFFSET szDisplayName
	mov   wc.hIconSm, 0
	invoke RegisterClassEx, addr wc

      mov rr.left, 0
      mov rr.top,  0  
      invoke GetSystemMetrics, SM_CXFULLSCREEN 
      mov rr.right, eax 
      invoke GetSystemMetrics, SM_CYFULLSCREEN 
      mov rr.bottom, eax

	INVOKE CreateWindowEx, NULL, ADDR szDisplayName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW, rr.left, rr.top, rr.right,\
           rr.bottom, NULL, NULL, hInst, NULL            
      mov   hwnd, eax

	INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
      StartLoop:
          INVOKE GetMessage, ADDR msg, NULL, 0, 0
          cmp eax, 0
          je ExitLoop 
          INVOKE TranslateMessage, ADDR msg
          INVOKE DispatchMessage, ADDR msg
          jmp StartLoop
       ExitLoop: 
          mov eax, msg.wParam
          ret           
WinMain ENDP

WndProc PROC  hWnd:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM 
        LOCAL hdc: HDC, hInst: HINSTANCE, ps:PAINTSTRUCT, rr: RECT 
        
       .if iMsg==WM_PAINT
         invoke BeginPaint, hWnd, ADDR ps
         mov hdc, eax

        invoke GetClientRect, hWnd, addr rect

        invoke DrawText, hdc, addr Windowsmsg, -1, addr rect,\
  	             DT_SINGLELINE or DT_CENTER or DT_VCENTER 

        invoke EndPaint, hWnd, ADDR ps         
   GetOut:      
      .ELSEIF iMsg==WM_DESTROY
         invoke PostQuitMessage,NULL
         ret 0
	.ENDIF
      invoke DefWindowProc, hWnd, iMsg, wParam, lParam
	ret  
WndProc ENDP 
            
end start
























































